#include <stdio.h>
#include "cv.h"
#include "cxcore.h"
#include "highgui.h"

#define PIXVAL(iplimagep, x, y) (*(uchar *)((iplimagep)->imageData + (y) * (iplimagep)->widthStep + (x)))

int main()
{
    int i, j;
    int thres = 128;
    IplImage *frame, *buf, *img;
    CvCapture *capture = cvCaptureFromCAM(0);
    if (capture == NULL) {
        fprintf(stderr, "cannot capture\n");
        return 1;
    }

    frame = cvQueryFrame(capture);
    buf = cvCreateImage(cvGetSize(frame), IPL_DEPTH_8U, 3);  // color
    img = cvCreateImage(cvGetSize(frame), IPL_DEPTH_8U, 1);  // mono, binarized

    cvNamedWindow("bin image", CV_WINDOW_AUTOSIZE);
    cvNamedWindow("frame", CV_WINDOW_AUTOSIZE);

    cvCreateTrackbar("threshold", "bin image", &thres, 255, NULL);

    while (1) {
        frame = cvQueryFrame(capture); /* cannot be modified */

        cvFlip(frame, buf, NULL);
        cvCvtColor(buf, img, CV_BGR2GRAY);

        for (j = 0; j < img->height; j++) {
            for (i = 0; i < img->width; i++) {
                if (PIXVAL(img, i, j) > thres) {
                    PIXVAL(img, i, j) = 255;
                } else {
                    PIXVAL(img, i, j) = 0;
                }
            }
        }

        cvShowImage("bin image", img);
        cvShowImage("frame", buf);

        if (cvWaitKey(30) > 0) {
            break;
        }
    }
    cvSaveImage("saved.jpg", buf);

    return 0;
}
