#include <stdio.h>
#include "cv.h"
#include "cxcore.h"
#include "highgui.h"

#define PIXVAL(iplimagep, x, y) (*(uchar *)((iplimagep)->imageData + (y) * (iplimagep)->widthStep + (x)))

int main()
{
    int i, j;
    IplImage *frame, *buf, *img, *back, *diff;
    CvCapture *capture = cvCaptureFromCAM(0);
    if (capture == NULL) {
        fprintf(stderr, "cannot capture\n");
        return 1;
    }

    frame = cvQueryFrame(capture);
    buf = cvCreateImage(cvGetSize(frame), IPL_DEPTH_8U, 3);  // color
    img = cvCreateImage(cvGetSize(frame), IPL_DEPTH_8U, 1);  // mono
    back = cvCreateImage(cvGetSize(frame), IPL_DEPTH_8U, 1); // previous frame
    diff = cvCreateImage(cvGetSize(frame), IPL_DEPTH_8S, 1); // frame diff

    cvNamedWindow("image", CV_WINDOW_AUTOSIZE);
    cvNamedWindow("frame", CV_WINDOW_AUTOSIZE);

    while (1) {
        frame = cvQueryFrame(capture); /* cannot be modified */

        cvFlip(frame, buf, NULL); /* copy it upside down */
        cvCvtColor(buf, img, CV_BGR2GRAY);

        for (j = 0; j < img->height; j++) {
            for (i = 0; i < img->width; i++) {
                int d = PIXVAL(img, i, j) - PIXVAL(back, i, j);
                PIXVAL(diff, i, j) = d / 2;
            }
        }

        cvCopy(img, back, 0);

        cvShowImage("image", diff);
        cvShowImage("frame", buf);

        if (cvWaitKey(30) > 0) {
            break;
        }
    }
    cvSaveImage("saved.jpg", buf);

    return 0;
}
